/*
 * Dialog
 *
 * Index
 * - Overlay
 * - Dialog
 * - Content
 * - Header
 * - Close
 * - Body
 * - Title
 * - Description
 * - Footer
 */

/**
 * @prop --z-index: The z-index of the Dialog.
 */

:host {
  --z-index: 3;

  position: fixed;
  top: 0;
  left: 0;
  z-index: var(--z-index);
  display: flex;
  align-items: center;
  justify-content: center;
  width: 100%;
  height: 100%;
  overflow: hidden;
  font-family: var(--road-font, sans-serif);
  line-height: 1.5;
  color: var(--road-on-surface);
  visibility: hidden !important;
  opacity: 0;
  transition: opacity 0.15s linear, visibility 0.15s;
}

/* OVERLAY
 -------------------- */

.dialog-overlay {
  position: absolute;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  display: block;
  touch-action: none;
  background: var(--road-overlay);
}

:host(.dialog-has-close) .dialog-overlay {
  cursor: pointer;
}

/* DIALOG
 -------------------- */

.dialog-modal {
  position: relative;
  width: auto;
  margin: 1rem;
  pointer-events: none;
  transition: transform 0.3s ease-out;
  transform: translateY(50px);
}

/**
 * Open state
 */

:host(.dialog-open) {
  visibility: visible !important;
  opacity: 1;
}

:host(.dialog-open) .dialog-modal {
  transform: none;
}

/* CONTENT
 -------------------- */

.dialog-content {
  position: relative;
  display: flex;
  flex-direction: column;
  width: 100%;
  padding: 0 0 1.5rem;
  pointer-events: auto;
  background: var(--road-surface);
  background-clip: padding-box;
  border-radius: 0.25rem;
  outline: 0;
  box-shadow: var(--road-elevation-highest);
}

@media (min-width: 576px) {

  .dialog-content {
    max-width: 454px;
  }
}

/* HEADER
 -------------------- */

.dialog-header {
  display: flex;
  align-items: center;
  justify-content: flex-end;
  height: 100%;
  max-height: 2.75rem;
  margin-bottom: 2rem;
}

/* CLOSE
 -------------------- */

.dialog-close {
  display: flex;
  align-items: center;
  align-self: flex-start;
  justify-content: center;
  width: 3.5rem;
  height: 3.5rem;
  padding: 0;
  color: inherit;
  cursor: pointer;
  background: transparent;
  border: 0;
  appearance: none;
  -webkit-tap-highlight-color: rgba(0, 0, 0, 0);
}

.dialog-icon {
  display: inline-block;
  width: 3rem;
  height: 3rem;
  font-size: var(--road-font-size-48);
}

/* BODY
 -------------------- */

.dialog-body {
  padding: 0 1.5rem;
  text-align: center;
}

@media (min-width: 768px) {

  .dialog-body {
    padding: 0 3rem;
  }
}

/* TITLE
 -------------------- */

.dialog-title {
  padding: 0;
  margin: 0 0 1rem;
  font-size: var(--road-body-medium);
  font-weight: 700;
  line-height: 1.2;
}

/* DESCRIPTION
 -------------------- */

.dialog-description {
  margin: 0 0 0.5rem;
  overflow: auto;
  font-size: var(--road-body-medium);
}

/* FOOTER
 -------------------- */

.dialog-footer {
  display: flex;
  justify-content: center;
  padding: 0 1.5rem;
}

.dialog-footer ::slotted(road-button) {
  margin-top: 1rem;
}

/**
 * Footer buttons
 */

.dialog-footer .btn {
  min-width: 130px;
  max-width: calc(50% - 0.5rem);
}
